#include <MacroPatternMatch.h>
#include "HROOTCoreTNamed.h"
#include "TRandom.h"
#include "HROOTMathTRandom.h"



#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TRandom)
TOBJECT_DEF_VIRT(TRandom)
DELETABLE_DEF_VIRT(TRandom)

TRANDOM_DEF_VIRT(TRandom)

TRANDOM_DEF_NONVIRT(TRandom)

